// u_53_constructor_constraint_factory
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_53_constructor_constraint_factory;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    create_factory_list_: TButton;
    create_a_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_factory_list_Click(Sender: TObject);
    procedure create_a_Click(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple, u_c_object_factory;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- using

    var g_c_object_factory: c_object_factory<c_ancestor>= Nil;

    procedure TForm1.create_factory_list_Click(Sender: TObject);
      begin
        g_c_object_factory:= c_object_factory<c_ancestor>.create_object_factory;
        g_c_object_factory.register_class<c_a>;
        g_c_object_factory.register_class<c_b>;
      end; // create_factory_list_Click

    procedure TForm1.create_a_Click(Sender: TObject);
      var l_c_a: c_ancestor;
      begin
        l_c_a:= g_c_object_factory.f_c_instance('c_a');
        display('created '+ l_c_a.ClassName);
        l_c_a.Free;
      end; // create_a_Click

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

